unit DBWind;
interface
uses Objects, DataCtrl, TVForms, DAE, DBFTable, DBGrids, Drivers, Dialogs,
     Menus, Ext_Crt, Ext_App, Dos, Views, Memory;
const
  FramesLine:array[0..2] of string[3] = ('ĳ','-|+','-|+');
  FrameType:byte = 0;
  FullFrames:boolean = false;
  RecPosStatus:PStaticText = nil;
  DelStatus:PStaticText = nil;
  IndexStatus:PStaticText = nil;
  InitClipboard:word = 2;
  StartupCodePage:word = 0;
  UseScreenSaver:boolean = true;
  IntervelScreenSaver:integer = 5;
  LngName:FNameStr='';
  ExclusiveMode:boolean = false;
  FindStr:string = '';
  RunEmptyCMD:boolean = false;
  UseAutoRefresh:boolean = false;
  isWait:boolean         = false;
  ShowRecNum : boolean   = true;

type
  TStrucRec = record
    Nom:Longint;
    Name:PString;
    FType:array [1..4] of char;
    Len,
    Dec:Longint;
  end;

type
  PDBWindow = ^TDBWindow;
  TDBWindow = object(TDialog)
    Table:PDbfTable;
    DBGrid:PDBGrid;
    DS:PDBSourse;
    CodePageStatus:PStaticText;
    LocalMenu:PMenuPopup;
    IsForm:boolean;
    RecNoField:PCalcField;
    constructor Init(FileName:FNameStr; ReadOnly:boolean);
    destructor Done;virtual;
    procedure HandleEvent(var Event:TEvent);virtual;
    procedure ChangeCodePage;
    procedure UpdateStatus;
    procedure EditTable;
    procedure DeleteRecal;
    procedure Print;
    procedure ViewStructure;
    procedure UpdatePos;
    procedure AppendRec;
    procedure PackTable;
    procedure ChangeCP;
    procedure FieldSumm;
    procedure EmptyTable;
    procedure EditMemo;
    procedure OptionsDlg;
    procedure FindRecord;
    procedure GoRecord;
    procedure SortRecords;
    procedure DelIndexFile;
    procedure IndexExpresion;
    procedure CreateIndex(Field:string; IndexOpt:TIndexOptions);
    procedure CopyStructure;
    procedure DirectEdit;
    procedure UserScreen;
    procedure AColors;
    procedure CreateRangeDialog;
    procedure CancelRange;
    procedure RecordCount;
    procedure FillRecords;
{    function CurFieldName:string;}
    procedure Filter;
    procedure SelectLngDlg;
    procedure QueryDelete;
    procedure ResortTable;
    procedure FormView;
    procedure FindMore;
    procedure SavePalette;
    procedure LoadPalette;
    procedure ImportFromSDF;
    procedure ImportFromDIFF;
    procedure ExportToSDF;
    procedure ExportToDIFF;
    procedure ArifmetProgres;
    procedure AddRecordsFromTable;
  private
    FormScrollBar:PScrollBar;
    EditList:PCollection;
    LastValue:integer;
    isTempIndex:boolean;
    function CurField:PField;
    procedure UpdateFieldNameCP;
    procedure UpdateFormLabes;
    procedure ScrollControls;
    procedure DoIdleFunc;
  end;

const
  DBWindow:PDBWindow = nil;

procedure ReindexProc(All,Pos:Longint; Info:PString);far;

procedure LoadIniFile;
procedure StoreIniFile;
procedure LoadLocaleInformation;
procedure RecPosStatusMouseEvent(Sender: PView; var Event: TEvent;
                           EventTime:TEventTime);far;

implementation
uses App, cmdbview, Ext_Str, DBCtrls, MsgBox, Clases, StdDlg,
     Ext_Dos, DBUtils, ResTools, Ext_Math, Ind_Unit, MemoEdit, Ext_Type,
     DAE_Type, IniFile, DBW_type, s_DBView, DBV_HLP, VMM, Register,
     Ext_Sys, Colors, Mdx_Unit
{$IFDEF WIN32}
     , Win32func
{$ENDIF}
     ;
const
 siPrinter = 'Printer';
procedure LoadIniFile;
var I:PIniFile;
begin
  I:=ApplicationIniFile;
  FrameType:=I^.ReadInteger(siPrinter,'Frame Type',FrameType);
  FramesLine[2]:=I^.ReadString(siPrinter,'Frame Chars',FramesLine[2]);
  FullFrames:=I^.ReadBoolean(siPrinter,'Full fames',FullFrames);
  InitClipboard:=I^.ReadInteger('System','Clipboard type',InitClipboard);
  byte(LocateOptions):=I^.ReadInteger('System','Find Options',byte(LocateOptions));
  ShowMemoValue:=I^.ReadBoolean('System','ShowMemoValue',ShowMemoValue);
  ShowSysField:=I^.ReadBoolean('System','Show system field',ShowSysField);
  DefMemoString:=I^.ReadString('System','DefMemoString',DefMemoString);
  BooleanText[true]:=I^.ReadString('System','Text for true',BooleanText[true]);
  BooleanText[false]:=I^.ReadString('System','Text for false',BooleanText[false]);
  ExclusiveMode:=I^.ReadBoolean('System','Exclusive mode', ExclusiveMode);
  RunEmptyCMD:=I^.ReadBoolean('System','RunEmptyCMD', RunEmptyCMD);
  UseAutoRefresh:=I^.ReadBoolean('System','UseAutoRefresh', UseAutoRefresh);
  ShowRecNum:=I^.ReadBoolean('System','ShowRecNum', ShowRecNum);
{$IFDEF SINGLE}
  LngName:=I^.ReadString('System','Language resurse',ExeName+'.EXE');
{$ELSE}
  LngName:=I^.ReadString('System','Language resurse',ExeName+'.TVR');
{$ENDIF}

  StartupCodePage:=I^.ReadInteger('System','Startup code page',StartupCodePage);
  DefaultDriver:=StrToInt(I^.ReadString('System','Default driver', '$'+IntToHex(DefaultDriver,2)));

  UseScreenSaver:=I^.ReadBoolean('Screen saver','Use screen saver',UseScreenSaver);
  IntervelScreenSaver:=I^.ReadInteger('Screen saver','Screen saver interval',IntervelScreenSaver);
  I^.Free;
end;

procedure StoreIniFile;
var I:PIniFile;
begin
  I:=ApplicationIniFile;
  I^.WriteInteger(siPrinter,'Frame Type',FrameType);
  I^.WriteString(siPrinter,'Frame Chars',FramesLine[2]);
  I^.WriteBoolean(siPrinter,'Full fames',FullFrames);
  I^.WriteInteger('System','Clipboard type',InitClipboard);
  I^.WriteInteger('System','Find Options',byte(LocateOptions));
  I^.WriteBoolean('System','ShowMemoValue',ShowMemoValue);
  I^.WriteBoolean('System','Show system field',ShowSysField);
  I^.WriteString('System','DefMemoString',DefMemoString);
  I^.WriteString('System','Text for true',BooleanText[true]);
  I^.WriteString('System','Text for false',BooleanText[false]);
  I^.WriteBoolean('System','RunEmptyCMD', RunEmptyCMD);
  I^.WriteBoolean('System','UseAutoRefresh', UseAutoRefresh);
  I^.WriteBoolean('System','ShowRecNum', ShowRecNum);
  I^.WriteInteger('System','Startup code page',StartupCodePage);
  I^.WriteBoolean('Screen saver','Use screen saver',UseScreenSaver);
  I^.WriteInteger('Screen saver','Screen saver interval',IntervelScreenSaver);
  I^.WriteString('System','Language resurse',LngName);
  I^.WriteBoolean('System','Exclusive mode', ExclusiveMode);
  I^.WriteString('System','Default driver', '$'+IntToHex(DefaultDriver,2));
  I^.Free;
end;

var
  CurProc, MaxLen:integer;
  MessageStr:string;

procedure InitMesseges;
begin
  CurProc:=0;
  MessageStr:=GetString(sWaitProgres);
  MaxLen:=Length(MessageStr)+Length(DBWindow^.Table^.TableName^)-1;
end;

procedure DoneMesseges;
begin
  ShowMessage('');
end;

procedure ReindexProc(All,Pos:Longint; Info:PString);
var Rec:TReindexRecord;
    B:TDrawBuffer;
    Color, Color1:word;
    i:integer;
    S:string;
begin
  Rec.Name:=Info;
  Rec.Count:=Round(Pos/All*100);
  if CurProc=Rec.Count then exit;
  CurProc:=Rec.Count;
  S:=Format(MessageStr, Rec);
  Color:=StatusLine^.GetColor(1);
  Color1:=$07;{StatusLine^.GetColor(2);}
  i:=Round(Pos/All*MaxLen);
  MoveChar(B, ' ', Color, StatusLine^.Size.X);
  MoveChar(B, ' ', Color1, i);
  isWait:=false;
  Application^.Idle;
  for i:=0 to Length(S)-1 do
    WordRec(B[i]).Lo:=byte(S[i+1]);
  StatusLine^.WriteBuf(0,0,StatusLine^.Size.X,1,B)
end;

procedure CodePageStatusMouseEvent(Sender: PView; var Event: TEvent;
                           EventTime:TEventTime);far;
begin
  if (Event.What = evMouseDown) {and (Event.Double)} then
    if Event.Buttons=mbRightButton then
      Message(DBWindow, evCommand, cmSelectLngDlg, nil)
    else  Message(DBWindow, evCommand, cmCodePage, nil)
end;

procedure RecPosStatusMouseEvent(Sender: PView; var Event: TEvent;
                           EventTime:TEventTime);
begin
  if (Event.What = evMouseDown) then
    if PStaticText(Sender)=RecPosStatus then Message(DBWindow, evCommand, cmGoRec, nil)
    else Message(DBWindow, evCommand, cmViewStru, nil)
end;

procedure CalcRecNo(Sender:PField; DataSet:PDataSet; var Data);far;
var Result:Longint absolute Data;
begin
  Result:=DataSet^.RecNo;
end;

constructor TDBWindow.Init(FileName:FNameStr; ReadOnly:boolean);
var R:TRect;
    ATable:PDbfTable;
    SB:PScrollBar;
    DScrol:PDataScroller;
    C:cardinal;
    S:string;
    Mode:word;
    P:PView;

function NotValidTable:boolean; {test table for valid}
var
  CurCount:array [1..2] of longint;
begin
  NotValidTable:=false;
  CurCount[1]:=(ATable^.DbfFile^.GetSize-ATable^.FileHeader^.HeaderSize) div ATable^.FileHeader^.RecordSize;
  if CurCount[1]<>ATable^.RecordCount then
  begin
    CurCount[2]:=ATable^.RecordCount;
    if RMessageBox(sNotValidTable,@CurCount, mfError+mfYesNo)=cmYes then
    begin
      ATable^.FileHeader^.RecordCount:=CurCount[1];
      ATable^.ApplyUpdates;
    end
    else NotValidTable:=true;
  end;
end;

begin
  Desktop^.GetExtent(R);
  if ReadOnly then Mode:=stOpenRead else Mode:=stOpen;
  ATable:=New(PDbfTable, Init(FileName, Mode));
  if (ATable=nil) or (ATable^.dsStatus<>dsOk) then
  begin
    if ATable<>nil then ATable^.Free;
    fail;
  end;
  if NotValidTable then fail;
  inherited Init(R, ATable^.TableName^);
  GrowMode:=GrowMode or gfGrowRel;
  EventMask:=EventMask or evResizeScreen;
  DBWindow:=@Self;
  Flags := 0;
  Palette:=dpBlueDialog;
  HelpCtx:=hcList;
  Table:=ATable;
  if ShowRecNum then
  begin
    RecNoField:=New(PCalcField, Init(Table, '', ftInteger, 5, 0));
    RecNoField^.OnGet:=CalcRecNo;
    RecNoField^.ReadOnly:=true;
    Table^.FieldDefs^.AtInsert(0, RecNoField);
  end;
  DS:=Insert(New(PDbSourse, init(Table)));
  SB:=insert(StandardScrollBar(sbHorizontal+sbHandleKeyboard));
  R.Assign(R.B.X-1,R.A.Y+1,R.B.X,R.B.Y-1);
  DScrol:=Insert(New(PDataScroller, Init(R, DS)));
  GetExtent(R);
  R.Grow(-1,-1);
  DBGrid:=Insert(New(PDBGrid, Init(R, SB, DS, DScrol)));
  DBGrid^.DBGridOptions:=DBGrid^.DBGridOptions + [dgEditing];
  DBGrid^.SetFixedColums(ord(ShowRecNum));
  R.Assign(1,0,15,1);
  CodePageStatus:=Insert(New(PStaticText, Init(R, '')));
  CodePageStatus^.OnMouseEvent:=CodePageStatusMouseEvent;
  CodePageStatus^.EventMask:=CodePageStatus^.EventMask or evMouseDown;
  case StartupCodePage of
    0:if (Table<>nil) and (Table^.FileHeader^.LanguageDriver in [dbfCP_1251,$57,$C9]) then
       C:=1251;
    1:C:=866;
    2:C:=1251;
  end;
  Table^.CodePageDrv:=Session^.GetCPDriver(C);
  UpdateFieldNameCP;
  UpdateStatus;
  S:=^C+TableVersion(Table, GetString(sDBaseIIIComp));
  Application^.GetExtent(R);
    R.A.X := 1;
    R.B.X := R.A.X + Length(s) + 2; R.B.Y := R.A.Y + 1;
  P:=Application^.Insert(New(PStaticText, Init(R, S)));
  P^.OnMouseEvent:=RecPosStatusMouseEvent;
  P^.EventMask:=P^.EventMask or evMouseDown;
  DisableCommands([cmFindMore]);
  {$IFDEF WIN32}
  InitNotyfy(ATable^.TableName^);
  {$ENDIF}
end;

destructor TDBWindow.Done;
begin
  {$IFDEF WIN32}
  StopNotification;
  {$ENDIF}
  if IsForm then
  begin
    Dispose(FormScrollBar, Done);
    FormScrollBar:=nil;
    Dispose(EditList, Done);
    EditList:=nil;
  end;
  if LocalMenu<>nil then
     LocalMenu^.Free;
  DelIndexFile;
  inherited Done;
end;

procedure TDBWindow.HandleEvent(var Event:TEvent);

procedure ResizeWindow;
var R:TRect;
begin
  Desktop^.GetExtent(R);
  ChangeBounds(R);
end;

procedure aLocalMenu;
var R:TRect;
    W:word;
begin
  R.Assign(10,10,20,20);
  if LocalMenu=nil then
     LocalMenu:=GetView(sLocalMenu);
  W:=Application^.ExecView(LocalMenu);
  if W<>cmCancel then
     Message(@Self, evCommand, W, nil);
end;

procedure FormCtrlReleasedFocus(Info:PView);
begin
  if IsForm then
  begin
    if Table^.State in [dsEdit, dsInsert] then Table^.Post;
  end;
end;

procedure ScrollForm(AForward:boolean);
begin
  if Table^.State in [dsEdit, dsInsert] then
  begin
    Current^.Valid(cmReleasedFocus);
    Table^.Post;
  end;
  if AForward then DBGrid^.NextRecord
  else DBGrid^.PrevRecord;
  ClearEvent(Event);
  DS^.UpData;
end;

procedure DoExit;
var E:TEvent;
begin
  E.What:=evCommand;
  E.Command:=cmQuit;
  E.InfoPtr:=nil;
  PutEvent(E);
end;

begin
  if (IsForm) and (Event.What=evKeyDown) and
     ((Event.KeyCode=kbPgUp) or (Event.KeyCode=kbPgDn)) then
     ScrollForm(Event.KeyCode=kbPgDn);
  inherited HandleEvent(Event);
  case Event.What of
    evCommand:begin
       case Event.Command of
         cmCodePage:ChangeCodePage;
         cmEdit:EditTable;
         cmDeleteRecal:DeleteRecal;
         cmPrint:Print;
         cmViewStru:ViewStructure;
         cmAppend:AppendRec;
         cmLocalMenu:aLocalMenu;
         cmPackTable:PackTable;
         cmChangeCodePage:ChangeCP;
         cmFieldSumm:FieldSumm;
         cmAbout:RExecDialog(sAbout, nil);
         cmEmptyTable:EmptyTable;
         cmDBWOptions:OptionsDlg;
         cmFindRec:FindRecord;
         cmGoRec:GoRecord;
         cmSortRecords:SortRecords;
         cmIndExpr:IndexExpresion;
         cmCopyStru:CopyStructure;
         cmDirectEdit:DirectEdit;
         cmUserScreen:UserScreen;
         cmColors:AColors;
         cmHiLoRange:CreateRangeDialog;
         cmCancelRange:CancelRange;
         cmRecordCount:RecordCount;
         cmFillRecords:FillRecords;
         cmFilter:Filter;
         cmSelectLngDlg:SelectLngDlg;
         cmQueryDelete:QueryDelete;
         cmResortTable:ResortTable;
         cmFormView:FormView;
         cmFindMore:FindMore;
         cmSavePalette:SavePalette;
         cmLoadPalette:LoadPalette;
         cmCancel:DoExit;
         cmImportFromSDF:ImportFromSDF;
         cmImportFromDIFF:ImportFromDIFF;
         cmExportToSDF:ExportToSDF;
         cmExportToDIFF:ExportToDIFF;
         cmArifmetProgres:ArifmetProgres;
         cmAddTable:AddRecordsFromTable;
       else
         exit;
       end;
       UpdateStatus;
    end;
    evBroadcast:
    case Event.Command of
      cmDBGridSelect:EditMemo;
      cmUpDataDS:UpdatePos;
      cmScrollBarChanged: if IsForm and (Event.InfoPtr=FormScrollBar) then
                            ScrollControls;

      cmReleasedFocus:begin
                        FormCtrlReleasedFocus(Event.InfoPtr);
                        exit;
                      end;
      cmIdle:
              begin
                DoIdleFunc;
                exit;
              end;
    else
      exit;
    end;
    evKeyDown:
    begin
      case Event.KeyCode of
        kbDel:DeleteRecal;
        kbIns:AppendRec;
        kbCtrlO:UserScreen;
        kbEnter:if IsForm then SelectNext(false);
        kbESC:DoExit;
      else
        exit;
      end;
       UpdateStatus;
    end;
    evResizeScreen:ResizeWindow;
  else
    exit;
  end;
  ClearEvent(Event);
end;

procedure TDBWindow.CreateRangeDialog;
var F:PField;
    Rec:TRangeRecord;
begin
  F:=PIndexObject(Table^.Index)^.IndexField;
  FillChar(Rec, SizeOf(TRangeRecord), 0);
  if Table^.StartRange<>nil then
  begin
    Table^.EditRangeStart;
    Rec.HiRangeStr:=F^.AsString;
    Table^.Cancel;
  end;
  if Table^.EndRange<>nil then
  begin
    Table^.EditRangeEnd;
    Rec.LoRangeStr:=F^.AsString;
    Table^.Cancel;
  end;
  if RExecDialog(sRangeDialog, @Rec)<>cmCancel then
  begin
    if Rec.HiRangeStr='' then Table^.CancelRangeStart
    else
    begin
      if Table^.StartRange<>nil then Table^.EditRangeStart
      else Table^.SetRangeStart;
      F^.SetAsString(Rec.HiRangeStr);
      Table^.ApplyRange;
    end;
    if Rec.LoRangeStr='' then Table^.CancelRangeEnd
    else
    begin
      if Table^.EndRange<>nil then Table^.EditRangeEnd
      else Table^.SetRangeEnd;
      F^.SetAsString(Rec.LoRangeStr);
      Table^.ApplyRange;
    end;
    DS^.Updata;
  end;
end;

procedure TDBWindow.CancelRange;
begin
  Table^.CancelRange;
  DS^.Updata;
end;

procedure TDBWindow.UpdateFieldNameCP;
procedure DoUpdate(P:PDBGridField);far;
begin
  with Table^ do
    if CodePageDrv<>nil then
    begin
      if (RecNoField=nil) or (PField(RecNoField)<>P^.Field) then
        AssignStr(P^.Name, CodePageDrv^.StrConvertTO(P^.Field^.Name^))
    end
    else
      AssignStr(P^.Name, P^.Field^.Name^);
end;
begin
  DBGrid^.FieldDefs^.ForEach(@DoUpdate);
  UpdateFormLabes;
end;

procedure TDBWindow.ChangeCodePage;
var C:cardinal;
begin
  if (Table^.CodePageDrv<>nil) and (Table^.CodePageDrv^.Version=1251) then C:=866
  else C:=1251;
  Table^.CodePageDrv:=Session^.GetCPDriver(C);
  UpdateFieldNameCP;
  UpdateStatus;
end;

procedure TDBWindow.UpdateStatus;
var S:string;
begin
  if Table^.CodePageDrv<>nil then S:=Table^.CodePageDrv^.Name
  else S:=GetString(sDos);
  AssignStr(CodePageStatus^.Text,S);
  DBGrid^.DrawView;
  CodePageStatus^.Size.X:=Length(CodePageStatus^.Text^);
  CodePageStatus^.DrawView;
  IndexStatus^.SetState(sfVisible,Table^.Index<>nil);
  SetCmdState([cmHiLoRange], (Table^.Index<>nil) and (not PIndexObject(Table^.Index)^.IndexField^.Calculated));
  SetCmdState([cmCancelRange], (Table^.StartRange<>nil) or (Table^.EndRange<>nil));
  UpdatePos;
end;

procedure TDBWindow.UpdatePos;
var s,DelS:string;
begin
  S:=IntToStr(Table^.RecNo)+' - '+IntToStr(Table^.RecordCount);
  AssignStr(RecPosStatus^.Text, S);
  RecPosStatus^.Size.X:=Length(RecPosStatus^.Text^);
  RecPosStatus^.DrawView;
  Frame^.DrawView;
  MenuBar^.DrawView;
  if DS^.DeletedRec then DelStatus^.Show
  else DelStatus^.Hide;
  StatusLine^.DrawView;
end;

procedure TDBWindow.EditTable;
begin
  if CurField^.FieldType in
                  [ftBCD, ftBytes, ftVarBytes, ftAutoInc,
                  ftBlob, ftMemo, ftGraphic, ftFmtMemo, ftParadoxOle,
                  ftDBaseOle, ftTypedBinary] then EditMemo
  else DBGrid^.EditData;
end;

procedure TDBWindow.DeleteRecal;
begin
  if DS^.DeletedRec then
  begin
    if RMessageBox(sConfirmRecal,nil,mfConfirmation+mfYesNo)=cmYes then
    begin
       Table^.Recall;
       DS^.Updata;
    end
  end
  else
  begin
    if RMessageBox(sConfirmDelete,nil,mfConfirmation+mfYesNo)=cmYes then
    DS^.DeleteRecord;
  end;
end;


procedure TDBWindow.ViewStructure;
var Rec:TInfoStruFormRecord;
    S,S1,S2:string;
    List:PStrings;
    StrucRec:TStrucRec;
    Field:PField;
    I:integer;
    St:TDosStream;
begin
  FillChar(Rec, SizeOf(TInfoStruFormRecord), 0);
  List:=New(PStrings, Init);
  Rec.ListBox1.List:=List;
  StrucRec.Name:=@S;
  Rec.LastUpdate:=@S2;
  for i:=0 to DS^.FieldCount-1 do
  begin
    if (RecNoField<>nil) and (i=0) then continue;
    Field:=DS^.FieldDefs^.At(i);
    if Table^.CodePageDrv<>nil then
      S:=Table^.CodePageDrv^.StrConvertTO(Field^.Name^)
    else
      S:=Field^.Name^;
    StrucRec.Nom:=i+1-ord(RecNoField<>nil);
    StrucRec.FType[1]:=Table^.FiType(Field^.FieldNo);
{    fTypeToChar(Field^.FieldType);}
    StrucRec.Len:=Field^.Size;
    StrucRec.Dec:=Field^.Precision;
    FormatStr(S1,'%3d '+FramesLine[FrameType][2]+
               '%-11s'+FramesLine[FrameType][2]+' %c '+
               FramesLine[FrameType][2]+' %3d '+
               FramesLine[FrameType][2]+'%3d',StrucRec);
    List^.Add(S1);
  end;
  Rec.ParamText1:=@S;
  S:=TableVersion(Table, GetString(sDBaseIIIComp));
  Rec.CountRecords:=Table^.RecordCount;
  Rec.RecordSize:=Table^.RecordSize;
  S2:=DateToStr(Table^.LastUpdate);
  if RExecDialog(sFileStruDlg, @Rec)=cmYes then
  begin
     St.Init(ReplaceExt(Table^.TableName^,'.txt',true), stCreate);
     WriteText(St, RFormat(sFileNameStru, Table^.TableName));
     WriteText(St,GetString(sSaveHead5)+FramesLine[FrameType][2]+
                  GetString(sSaveHead1)+FramesLine[FrameType][2]+
                  GetString(sSaveHead2)+FramesLine[FrameType][2]+
                  GetString(sSaveHead3)+FramesLine[FrameType][2]+
                  GetString(sSaveHead4)+
                  DupChar(FramesLine[FrameType][1],4)+
                  FramesLine[FrameType][3]+
                  DupChar(FramesLine[FrameType][1],11)+
                  FramesLine[FrameType][3]+
                  DupChar(FramesLine[FrameType][1],3)+
                  FramesLine[FrameType][3]+
                  DupChar(FramesLine[FrameType][1],5)+
                  FramesLine[FrameType][3]+
                  DupChar(FramesLine[FrameType][1],4));
     List^.SaveToStream(St);
     St.Done;
  end;
  Dispose(List, Done);
end;

procedure TDBWindow.AppendRec;
begin
    if RMessageBox(sConfirmAppend,nil,mfConfirmation+mfYesNo)=cmYes then
    begin
       DS^.Append;
       DS^.Post;
    end;
end;

procedure TDBWindow.PackTable;
begin
  if RMessageBox(sConfirmPack,nil,mfConfirmation+mfYesNo)=cmYes then
  begin
    InitMesseges;
    dbuPackTable(Table, ReindexProc);
    DS^.UpData;
    DoneMesseges;
  end;
end;

procedure TDBWindow.ChangeCP;
{var Target:boolean;
    S:string;
    I:Longint;
    j:integer;
    F:PMemoField;
    P:PMemoRec;
    MemoSize:word;
begin}
var LB:TListBoxRec;
    List:PStrings;
    I:Longint;
    P1,P2:PCodePageDrv;
begin
  RMessageBox(sNotImplemented, nil, mfOkButton);
  exit;
  LB.Selection:=0;
  List:=New(PStrings, Init);
  LB.List:=List;
  List^.Add(GetString(sDOSText));
  for i:=0 to Session^.CodePageCollections^.Count-1 do
  begin
    List^.Add(PCodePageDrv(Session^.CodePageCollections^.At(i))^.Name);
    if Table^.CodePageDrv=Session^.CodePageCollections^.At(i) then LB.Selection:=i+1;
  end;
  if RExecDialog(sSelectLngForDLG, @LB)<>cmCancel then
  begin
    P1:=Table^.CodePageDrv;
    P2:=PCodePageDrv(Session^.CodePageCollections^.At(LB.Selection));
    if P1<>P2 then
    with Table^ do
    begin
      for i:=1 to RecordCount do
      begin
      end;
    end;
{    if LB.Selection=0 then Table^.CodePageDrv:=nil
    else Table^.CodePageDrv:=Session^.CodePageCollections^.At(LB.Selection-1);
    UpdateFieldNameCP;}
    UpdateStatus;
  end;
  Dispose(List, Done);
(*  Target:=Assigned(Table^.LangDriver);
  if RMessageBox(sTargetDTW+byte(Target),nil,mfConfirmation+mfYesNo)=cmYes then
  begin
    with Table^ do
    for i:=1 to RecordCount do
    begin
      Go(i);
      Edit;
      for j:=0 to FieldDefs^.Count-1 do
        if Fields(j)^.FieldType=ftMemo then
        begin
          PField(F):=Fields(j);
          MemoSize:=F^.GetSize+SizeOf(Word);
          GetMem(P, MemoSize);
          F^.GetData(P^);
          if Target then LangDriver:=nil
          else LangDriver:=CP1251;
          F^.SetData(P^);
          if Target then LangDriver:=CP1251
          else LangDriver:=nil;
          FreeMem(P, MemoSize);
        end;
      if Target then LangDriver:=nil
      else LangDriver:=CP1251;
      Post;
      if Target then LangDriver:=CP1251
      else LangDriver:=nil;
      ReindexProc(RecordCount, i, TableName);
procedure InitMesseges;
procedure DoneMesseges;

    end;
    if Target then Table^.LangDriver:=nil
    else Table^.LangDriver:=CP1251;
    Table^.First;
    DS^.UpData;
{    UpdateStatus;}
  end; *)
end;

procedure TDBWindow.FieldSumm;
var Sum:extended;
    S:string;
    P:Pointer;
    Field:PField;
    i:longint;
    Result:boolean;
begin
  Field:=CurField;
  with Table^ do
  if Field^.FieldType in [ftSmallint,ftInteger,ftWord,ftFloat,ftCurrency] then
  begin
    InitMesseges;
    P:=GetBookmark;
    Sum:=0;
    First;
    i:=0;
    while not Eof do
    begin
      Sum:=Sum+Field^.AsFloat;
      Next;
      inc(i);
      ReindexProc(RecordCount, i, TableName);
    end;
    S:=FloatToStr(Sum);
    GotoBookmark(P);
    FreeBookmark(P);
    Result:=true;
    DoneMesseges;
  end
  else Result:=false;
  P:=@S;
  RMessageBox(byte(Result)+sFieldNotSum, @P,mfConfirmation+mfOkButton);
end;

procedure TDBWindow.EmptyTable;
begin
  if RMessageBox(sConfirmEmpty,nil,mfConfirmation+mfYesNo)=cmYes then
  begin
    Table^.EmptyTable;
    DS^.UpData;
    UpdateStatus;
  end;
end;

procedure TDBWindow.EditMemo;
var
  PRec:PMemoRec;
  Len:word;
begin
  Table^.Edit;
  if Application^.ExecuteDialog(NewForm3(DS, CurField), nil)<>cmCancel then
    Table^.Post
  else Table^.Cancel;
end;

procedure TDBWindow.Print;
var Rec:TPrintFormRecord;
    i,j:integer;
    FName:FNameStr;
    S:PDosStream;
    List:PStrings;
    St, OldFilter:string;
    OldFiltred:boolean;
    DBGF:PDBGridField;
    FieldList:PCollection;
    Count:Longint;

procedure NextLine;
begin
  St:=#13#10;
  S^.Write(St[1], Length(St));
end;

procedure DoWriteTitle(P:PDBGridField);far;
var Str:string;
begin
  Str:=P^.Name^;
  FillSpace(Str, P^.GetSize);
  Str:=Str+FramesLine[FrameType][2];
  S^.Write(Str[1], Length(Str));
end;

procedure DoWrite(P:PDBGridField);far;
var Str:string;
begin
  Str:=P^.Field^.DisplayText;
  FillSpace(Str, P^.GetSize);
{  //Str:=P^.GetText(P^.GetSize+1);
  Str:=MakeAlign(P^.Align, P^.Field^.DisplayText, P^.GetSize);}
  Str:=Str+FramesLine[FrameType][2];
  S^.Write(Str[1], Length(Str));
end;

procedure PrintNumberLineHeader;
var Str:string;
begin
  case Rec.RadioButtons2 of
    1:Str:='RecNo.';
    2:Str:='LineNo';
  else
    exit;
  end;
  Str:=Str+FramesLine[FrameType][2];
  S^.Write(Str[1], Length(Str));
end;

procedure PrintNumberLine;
var St:string;
begin
  case Rec.RadioButtons2 of
    1:Str(Table^.RecNo:6,St);
    2:Str((Count+1):6,St);
  else
    exit;
  end;
  St:=St+FramesLine[FrameType][2];
  S^.Write(St[1], Length(St));
end;

procedure WriteSeparator;
var St:string;
procedure DoWriteSeparator(P:PDBGridField);far;
begin
  St:=(DupChar(FramesLine[FrameType][1], P^.GetSize));
  St:=St+FramesLine[FrameType][3];
  S^.Write(St[1], Length(St));
end;

begin
  if Rec.RadioButtons2 in [1..2] then
  begin
    St:=(DupChar(FramesLine[FrameType][1], 6));
    St:=St+FramesLine[FrameType][3];
    S^.Write(St[1], Length(St));
  end;
  FieldList^.ForEach(@DoWriteSeparator);
end;

begin
  OldFilter:=DinamicStr(Table^.Filter);
  OldFiltred:=Table^.Filtred;
  FillChar(Rec, SizeOf(Rec), 0);
  List:=New(PStrings, Init);
  Rec.MultiSelBox1.List:=List;
  with Table^ do
  begin
    j:=ord(RecNoField<>nil);
    if CodePageDrv<>nil then
      for i:=j to FieldCount-1 do
        List^.Add(' '+CodePageDrv^.StrConvertTo(Fields(i)^.Name^))
    else
      for i:=j to FieldCount-1 do
        List^.Add(' '+Fields(i)^.Name^);
  end;
  FName:=stLoCase(ReplaceExt(Table^.TableName^,'.prn',true));
  if (RExecDialog(sPrintDlg,@Rec)<>cmCancel) and
     (RExecDialog(sSavePrnFile, @FName)<>cmCancel) then
  begin
     FieldList:=New(PCollection, Init(10,5));
     j:=ord(RecNoField<>nil);
     for i:=0 to List^.Count-1 do
     begin
       St:=List^.Str(i);
       if St[1]=#251 then
          FieldList^.Insert(DBGrid^.FieldDefs^.At(i+j));
     end;
     S:=New(PDosStream, Init(FName, stCreate));
     PrintNumberLineHeader;
     FieldList^.ForEach(@DoWriteTitle);
     NextLine;
     WriteSeparator;
     NextLine;
     if Rec.Filter<>'' then
     begin
       Table^.SetFilter(Rec.Filter);
       Table^.SetFiltred(true);
     end;
     InitMesseges;
     Count:=0;
     Table^.First;
     while not Table^.Eof do
     begin
       PrintNumberLine;
       FieldList^.ForEach(@DoWrite);
       NextLine;
       if FullFrames then
       begin
         WriteSeparator;
         NextLine;
       end;
       Table^.Next;
       inc(Count);
       ReindexProc(Table^.RecordCount,Count, Table^.TableName);
     end;
     Table^.SetFiltred(false);
     DoneMesseges;
     S^.Free;
     FieldList^.DeleteAll;
     Dispose(FieldList, Done);
     DS^.SetFilter(OldFilter);
     DS^.SetFiltred(OldFiltred);
  end;
  PObject(Rec.MultiSelBox1.List)^.Free;
end;


procedure TDBWindow.OptionsDlg;
var Rec1:TOptionsRec;
    S:FNameStr;
    TempF, TempF1:Boolean;
    TempByte:Byte;
const
    DefCStringDrivers = Char(verNone) + Char(verDBase2) +
                        Char(verDBase3) +
                       Char(verDBase3) + Char(verDBase3) +
                       Char(verFoxPro2XMemo) + Char(verFoxPro2XMemo) +
                       Char(verDBase7);
var
   DefStringDrivers:string[Length(DefCStringDrivers)];

procedure DoFindLngFiles;
procedure DoAddNames(FName:FNameStr);
var RFile: TResourceFile;
    RStream: PStream;
    RStrings: PStringList;
begin
  RStream:=New(PBufStream, Init( ExePath+FName, stOpenRead, 4096));
  RFile.Init(RStream);
  RStrings := PStringList(RFile.Get('Strings'));
  PStrings(Rec1.Language.List)^.Add(FName+DupChar(' ',12-Length(FName))+' - '+RStrings^.Get(sLanguage));
  RStrings^.Free;
  RFile.Done;
end;
var
  DirInfo: SearchRec;
  I:integer;
begin
  i:=0;
{$IFDEF SINGLE}
  DoAddNames(ExeName+'.EXE');
{$ELSE}
  DoAddNames(ExeName+'.TVR');
{$ENDIF}
  FindFirst(ExePath+'DBV*.LNG', Archive, DirInfo);
  while DosError = 0 do
  begin
    DoAddNames(DirInfo.Name);
    inc(i);
    if stUpCase(LngName)=DirInfo.Name then Rec1.Language.Selection:=i;
    FindNext(DirInfo);
  end;
end;

begin
  FillChar(Rec1, SizeOf(TOptionsRec), 0);
  DefStringDrivers:=DefCStringDrivers;
  Rec1.Cliboard:=InitClipboard;
  Rec1.CodePage:=StartupCodePage;
  Rec1.UseScreenSaver:=ord(UseScreenSaver)+ord(RunEmptyCMD)*2+ord(UseAutoRefresh)*4;
  Rec1.ScreenSaverInterval:=IntervelScreenSaver;
  Rec1.ShowMemoVal:=byte(ShowMemoValue) + (Byte(ShowSysField) shl 1) + (Byte(ShowRecNum) shl 2);
  Rec1.MemoFiler:=DefMemoString;
  Rec1.TrueText:=BooleanText[true];
  Rec1.FalseText:=BooleanText[false];
  Rec1.FramesType:=FrameType;
  Rec1.FullFrames:=byte(FullFrames);
  Rec1.HFrameChar:=FramesLine[2][1];
  Rec1.VFrameChar:=FramesLine[2][2];
  Rec1.CFrameChar:=FramesLine[2][3];
  Rec1.Language.List:=New(PStrings, Init);
  Rec1.ExclusiveMode:=Ord(ExclusiveMode);
  case DefaultDriver of
    verNone             :Rec1.DefaultDriver:=0;
    verDBase2           :Rec1.DefaultDriver:=1;
    verDBase3           :Rec1.DefaultDriver:=2;
    verFoxPro2XMemo     :Rec1.DefaultDriver:=5;
    verDBase7           :Rec1.DefaultDriver:=7;
    verDBase7Memo       :Rec1.DefaultDriver:=7;
    verVFP              :Rec1.DefaultDriver:=8;
  else
    Rec1.DefaultDriver:=2;
  end;
  DoFindLngFiles;
  if RExecDialog(sOptionsDlg, @Rec1)<>cmCancel then
  begin
    UseScreenSaver:=(Rec1.UseScreenSaver and $0001)<>0;
    RunEmptyCMD:=(Rec1.UseScreenSaver and $0002)<>0;
    UseAutoRefresh:=(Rec1.UseScreenSaver and $0004)<>0;
    IntervelScreenSaver:=Rec1.ScreenSaverInterval;
    InitClipboard:=Rec1.Cliboard;
    StartupCodePage:=Rec1.CodePage;
    ShowMemoValue:=(Rec1.ShowMemoVal and $01) <> 0;
    TempF:=(Rec1.ShowMemoVal and $02) <> 0;
    TempF1:=(Rec1.ShowMemoVal and $04) <> 0;
    DefMemoString:=Rec1.MemoFiler;
    BooleanText[true]:=Rec1.TrueText;
    BooleanText[false]:=Rec1.FalseText;
    FrameType:=Rec1.FramesType;
    byte(FullFrames):=Rec1.FullFrames;
    FramesLine[2][1]:=Rec1.HFrameChar[1];
    FramesLine[2][2]:=Rec1.VFrameChar[1];
    FramesLine[2][3]:=Rec1.CFrameChar[1];
    LngName:=Trim(Copy(PStrings(Rec1.Language.List)^.Str(Rec1.Language.Selection),1,12));
    TempByte:=byte(DefStringDrivers[Rec1.DefaultDriver+1]);
    if (stUpCase(ExePath+LngName)<>stUpCase(TVRName)) or
       (Rec1.ExclusiveMode<>Ord(ExclusiveMode)) or
       (ShowSysField<>TempF) or
       (TempByte <> DefaultDriver) or
       (ShowRecNum<>TempF1) then
       RMessageBox(sReload, nil, mfOkButton+mfWarning);
    ExclusiveMode:=Rec1.ExclusiveMode<>0;
    ShowSysField:=TempF;
    DefaultDriver:=TempByte;
    ShowRecNum:=TempF1;
    StoreIniFile;
    ReDraw;
  end;
  Dispose(PObject(Rec1.Language.List), Done);
end;

function TDBWindow.CurField:PField;
begin
  if IsForm then
    if TypeOf(Current^)<>TypeOf(TDBEdit) then CurField:=nil
    else CurField:=PDBEdit(Current)^.Field
  else CurField:=DBGrid^.CurentField^.Field;
end;

procedure TDBWindow.FindRecord;
var F:PField;
    FindRec:TFindFormRecord;
    P:PView;
begin
  F:=CurField;
  FindRec.InputLine1:=F^.AsString;
  FindRec.CheckBoxes1:=byte(LocateOptions);
  if RExecDialog(sFindForm,@FindRec)<>cmCancel then
  begin
     FindStr:=FindRec.InputLine1;
     byte(LocateOptions):=FindRec.CheckBoxes1;
     DS^.SetKey;
     F^.SetAsString(FindRec.InputLine1);
     DS^.Location;
  end;
  if FindStr<>'' then EnableCommands([cmFindMore])
  else DisableCommands([cmFindMore]);
end;

procedure TDBWindow.GoRecord;
var L:Longint;
begin
  L:=DS^.RecNo;
  if RExecDialog(sGoForm,@L)<>cmCancel then
  begin
     DS^.Go(L);
     DS^.UpData;
  end;
end;

procedure TDBWindow.DelIndexFile;
var S:FNameStr;
begin
  if (Table^.Index=nil) and
     (not isTempIndex) then exit;
  Table^.IndexDefs^.Delete(Table^.Index);
  S:=PIndexObject(Table^.Index)^.FileName^;
  PObject(Table^.Index)^.Free;
  Table^.Index:=nil;
  Table^.First;
  DeleteFile(S);
  DS^.UpData;
  isTempIndex:=false;
end;

procedure TDBWindow.CreateIndex(Field:string; IndexOpt:TIndexOptions);
var
  i:Longint;
  PathFormat, IndexName:string;
begin
  DelIndexFile;
  i:=-1;
  PathFormat:=TempDir+'_%07d.ind';
  repeat
    inc(i);
    IndexName:=Format(PathFormat,i);
  until (i>999) or not FileExists(IndexName);
  if FileExists(IndexName) then exit;
  Table^.CreateIndex(IndexName, Field, IndexOpt);
  DS^.UpData;
  isTempIndex:=true;
end;

procedure TDBWindow.SortRecords;
begin
  if Table^.Index<>nil then DelIndexFile
  else CreateIndex(CurField^.Name^,[]);
end;

procedure TDBWindow.IndexExpresion;
var S:string[60];
begin
  S:='';
  if RExecDialog(sIndexExpresDlg,@S)<>cmCancel then
     CreateIndex(S, []);
end;

procedure TDBWindow.CopyStructure;
var FName:FNameStr;
begin
  FName:='*.dbf';
  if RExecDialog(sCopyStruct, @FName)<>cmCancel then
    Table^.CopyStructure(FName);
end;

{function TDBWindow.CurFieldName:string;
begin
  CurFieldName:=CurField^.Name^;
end;}

procedure TDBWindow.DirectEdit;
var Rec:TFieldDirectFormRecord;
    FiNo:integer;
    S:string;
begin
  FiNo:=CurField^.FieldNo;
  if Table^.CodePageDrv<>nil then
     S:=Table^.CodePageDrv^.StrConvertTO(CurField^.Name^)
  else S:=Table^.FiName(FiNo);
  Rec.InputLine1:=Table^.GetFields(FiNo);
  Rec.FieldName:=@S;
  Rec.FieldSize:=Table^.FiLength(FiNo);
  if RExecDialog(sDirectFieldEditor, @Rec)<>cmCancel then
  begin
    Table^.Edit;
    Table^.PutFields(FiNo,Rec.InputLine1);
    Table^.Post;
  end;
end;

procedure TDBWindow.UserScreen;
begin
  RestoreScreen;
  WaitPress;
  ClearScreen;
  Application^.Redraw;
end;

procedure TDBWindow.AColors;
begin
  if RExecDialog(sColorDlg, Application^.GetPalette) <> cmCancel then
  begin
    DoneMemory;
    Application^.ReDraw;
  end;
end;

procedure TDBWindow.RecordCount;
var P:PBookmark;
    Count:Longint;
begin
  P:=Table^.GetBookmark;
  Count:=0;
  InitMesseges;
  Table^.First;
  while not Table^.Eof do
  begin
    inc(Count);
    Table^.Next;
    ReindexProc(Table^.RecordCount,Count, Table^.TableName);
  end;
  Table^.GotoBookmark(P);
  Table^.FreeBookmark(P);
  DoneMesseges;
  RMessageBox(sRecordCount, @Count, mfInformation+mfOkButton);
end;

procedure TDBWindow.FillRecords;
var D:PDialog;
    DBEdit:PDBEdit;
    P:PString;
    S:string;
    PP:PBookmark;
    Count:Longint;
    B:boolean;
    F:PField;
begin
  F:=CurField;
  if F=PField(RecNoField) then exit;
  D:=GetView(sReplaseForm);
  if D<>nil then
  begin
    DBEdit:=D^.FindComponent('DBEdit1');
    DBEdit^.ConectBase(DS, F^.Name^);
    Table^.Edit;
    B:=Application^.ExecuteDialog(D, @F^.Name)<>cmCancel;
    S:=F^.AsString;
    Table^.Cancel;
    if B then
    begin
      PP:=Table^.GetBookmark;
      Count:=0;
      InitMesseges;
      Table^.First;
      while not Table^.Eof do
      begin
        Table^.Edit;
        F^.SetAsString(S);
        Table^.Post;
        inc(Count);
        Table^.Next;
        ReindexProc(Table^.RecordCount,Count, Table^.TableName);
      end;
      Table^.GotoBookmark(PP);
      Table^.FreeBookmark(PP);
      DoneMesseges;
    end;
  end;
end;

procedure TDBWindow.Filter;
var s:string;
begin
  S:=DS^.Filter;
  if RExecDialog(sFilterForm, @S)<>cmCancel then
  begin
    if S<>'' then DS^.SetFilter(S);
    DS^.SetFiltred(S<>'');
  end;
end;

procedure TDBWindow.SelectLngDlg;
var LB:TListBoxRec;
    List:PStrings;
    I:integer;
begin
  LB.Selection:=0;
  List:=New(PStrings, Init);
  LB.List:=List;
  List^.Add(GetString(sDOSText));
  for i:=0 to Session^.CodePageCollections^.Count-1 do
  begin
    List^.Add(PCodePageDrv(Session^.CodePageCollections^.At(i))^.Name);
    if Table^.CodePageDrv=Session^.CodePageCollections^.At(i) then LB.Selection:=i+1;
  end;
  if RExecDialog(sSelectLng, @LB)<>cmCancel then
  begin
    if LB.Selection=0 then Table^.CodePageDrv:=nil
    else Table^.CodePageDrv:=Session^.CodePageCollections^.At(LB.Selection-1);
    UpdateFieldNameCP;
    UpdateStatus;
  end;
  Dispose(List, Done);
end;

procedure TDBWindow.QueryDelete;
var Rec:TQueryDelete;
    TempFilter:string;
begin
  Rec.TableName:=Table^.TableName;
  Rec.Expresion:='';
  if ExecDialog('QueryDelete',@Rec)=cmOk then
  begin
    if Table^.Filtred then TempFilter:=DinamicStr(Table^.Filter)
    else TempFilter:='';
    Table^.First;
    Table^.SetFilter(Rec.Expresion);
    Table^.SetFiltred(Rec.Expresion<>'');
    while not Table^.Eof do
    begin
      Table^.Delete;
      Table^.Next;
    end;
    Table^.SetFilter(TempFilter);
    Table^.SetFiltred(TempFilter<>'');
  end;
end;

procedure TDBWindow.ResortTable;
var Rec:TSelectFieldSortRecord;
    List:PStrings;
    I:integer;
    Temp:PDbfTable;
    NewFileName:string;
    IndexOpt:TIndexOptions;
begin
  FillChar(Rec, SizeOf(Rec), 0);
  List:=New(PStrings, Init);
  Rec.FieldList.List:=List;
  with Table^ do
    if CodePageDrv<>nil then
      for i:=0 to FieldCount-1 do
        List^.Add(' '+CodePageDrv^.StrConvertTo(Fields(i)^.Name^))
    else
      for i:=0 to FieldCount-1 do
        List^.Add(' '+Fields(i)^.Name^);

  if ExecDialog('SelectFSort', @Rec)<>cmCancel then
  begin
    IndexOpt:=[];
    if Rec.Order=1 then IndexOpt:=IndexOpt+[ixDescending];
    NewFileName:=GetTempName(Table^.TableName^);
    Table^.CopyStructure(NewFileName);
    Temp:=New(PDbfTable, Init(NewFileName, stOpen));
    Temp^.CodePageDrv:=Table^.CodePageDrv;
    CreateIndex(Table^.Fields(Rec.FieldList.Selection)^.Name^,IndexOpt);
    Table^.First;
    while not Table^.Eof do
    begin
      Temp^.Append;
      Move(Table^.RecBuf^, Temp^.RecBuf^, Table^.RecordSize);
      Temp^.Post;
      Table^.Next;
    end;
    DelIndexFile;
    Table^.Close;
    DeleteFile(Table^.TableName^);
    Temp^.RenameTable(Table^.TableName^);
    Temp^.Free;
    Table^.Open;
    DS^.FirstRec;
  end;
  Dispose(List, Done);
end;

procedure EditData(Sender: PView; var Event: TEvent;
                           EventTime:TEventTime);far;
begin
  if EventTime=etComponent then
  begin
    if (Event.What=evKeyDown) then
      if Event.KeyCode=kbEsc then
      begin
        if DBWindow^.Table^.State in [dsEdit, dsInsert] then
        begin
          DBWindow^.Table^.Cancel;
          Sender^.ClearEvent(Event);
        end;
      end
      else
      if Event.CharCode in [#9,#32..#255] then
      begin
        if DBWindow^.Table^.State<>dsEdit then
        begin
          DBWindow^.Table^.Edit;
        end;
      end;
  end;
end;

procedure TDBWindow.FormView;
var R:TRect;
    E:PDBEdit;
    L:PLabel;
    ASize, i:integer;
begin
  IsForm:=not IsForm;
  Lock;
  DBGrid^.SetState(sfVisible, not IsForm);
  DBGrid^.SetState(sfDisabled, IsForm);
  if IsForm then
  begin
    Palette:=dpCyanDialog;
    FormScrollBar:=StandardScrollBar(sbVertical or sbHandleKeyBoard);
    FormScrollBar^.SetRange(0, Table^.FieldCount*2-Size.Y+2);
    FormScrollBar^.SetStep(6,1);
    EditList:=New(PCollection, Init(Table^.FieldCount*4, 0));
    for i:=0 to Table^.FieldCount-1 do
    begin
      if Table^.Fields(i)=PField(RecNoField) then continue;
      if Table^.Fields(i)^.FieldType=ftMemo then ASize:=79
      else ASize:=Min(Table^.Fields(i)^.Size+15, 79);
      R.Assign(11,i*2+1, ASize,i*2+2);
      E:=Insert(New(PDBEdit, Init(R, DS, Table^.Fields(i)^.Name^)));
      E^.OnKeyEvent:=EditData;
      if (E^.Origin.Y<1) or (E^.Origin.Y+E^.Size.Y>Size.Y-1) then E^.Hide;
      R.Assign(1,i*2+1,10,i*2+2);
      L:=Insert(New(PLabel, Init(R, Table^.Fields(i)^.Name^, E)));
      EditList^.Insert(L);
      EditList^.Insert(E);
    end;
    UpdateFormLabes;
    SelectNext(false);
  end
  else
  begin
    Palette:=dpBlueDialog;
    Dispose(FormScrollBar, Done);
    FormScrollBar:=nil;
    Dispose(EditList, Done);
    EditList:=nil;
    LastValue:=0;
  end;
  UnLock;
end;

procedure TDBWindow.UpdateFormLabes;
procedure DoUpdate(P:PLabel);far;
begin
  if TypeOf(P^)=TypeOf(TLabel) then
  begin
    if Table^.CodePageDrv<>nil then
      AssignStr(P^.Text, Table^.CodePageDrv^.StrConvertTO(PDBEdit(P^.Link)^.Field^.Name^))
    else
      AssignStr(P^.Text, PDBEdit(P^.Link)^.Field^.Name^);
  end;
end;
begin
  if EditList<>nil then
  begin
    EditList^.ForEach(@DoUpdate);
    Redraw;
  end;
end;

procedure TDBWindow.ScrollControls;
var Step:integer;
procedure ScrollSubView(P:PView);far;
begin
  if (PFrame(P)<>Frame) and
     (PScrollBar(P)<>FormScrollBar) and
     (PDBGrid(P)<>DBGrid) and
     (PStaticText(P)<>CodePageStatus) and
     (PScrollBar(P)<>DBGrid^.ScrollBar) and
     (PDataScroller(P)<>DBGrid^.DataScroller) then
  begin
    P^.MoveTo(P^.Origin.X, P^.Origin.Y-Step);
    if (P^.Origin.Y<1) or (P^.Origin.Y+P^.Size.Y>Size.Y-1) then P^.Hide
    else P^.Show;
  end;
end;
var
  Cur:PView;
begin
  Step:=FormScrollBar^.Value-LastValue;
  LastValue:=FormScrollBar^.Value;
  Lock;
  Cur:=Current;
  ForEach(@ScrollSubView);
  if Cur^.State and sfVisible <> 0 then Cur^.Select
  else
  if Step>0 then SelectNext(false);
  UnLock;
end;

procedure TDBWindow.FindMore;
var TempS:TSearchOptions;
    P:PBookmark;
begin
  TempS:=LocateOptions;
  LocateOptions:=LocateOptions-[soGoFirst];
  P:=Table^.GetBookmark;
  Table^.Next;
  DS^.SetKey;
  CurField^.SetAsString(FindStr);
  if not DS^.Location then
  begin
    RMessageBox(sRecordNotFound, nil, mfOkButton);
    Table^.GotoBookmark(P);
  end
  else DS^.Updata;
  Table^.FreeBookmark(P);
  LocateOptions:=TempS;
end;

procedure TDBWindow.SavePalette;
var S:FNameStr;
    St:PDosStream;
begin
  S:=PaletteMask;
  if ExecDialog('PalSave',@S)<>cmCancel then
  begin
    St:=New(PDosStream, Init(S, stCreate));
    St^.Write(Application^.GetPalette^[1], Length(Application^.GetPalette^));
    Dispose(St, Done);
  end;
end;

procedure TDBWindow.LoadPalette;
begin
  SelectNewColors;
end;

procedure TDBWindow.ImportFromSDF;
begin
  RMessageBox(sNotImplemented, nil, mfOkButton);
end;
procedure TDBWindow.ImportFromDIFF;
begin
  RMessageBox(sNotImplemented, nil, mfOkButton);
end;
procedure TDBWindow.ExportToSDF;
begin
  RMessageBox(sNotImplemented, nil, mfOkButton);
end;
procedure TDBWindow.ExportToDIFF;
begin
  RMessageBox(sNotImplemented, nil, mfOkButton);
end;

procedure TDBWindow.ArifmetProgres;
var Rec:TArifmeticProgersRecord;
    I, Count:Longint;
    F:PField;
    CurPos:PBookmark;

function TableEof:boolean;
begin
  case Rec.OptionsEdit of
    0:TableEof:=Table^.Eof;
    3:TableEof:=(Count>Rec.CountEdit) or Table^.Eof;
  else
    TableEof:=true;
  end;
end;

function TableBof:boolean;
begin
  case Rec.OptionsEdit of
    0:TableBof:=Table^.Bof;
    3:TableBof:=(Count>Rec.CountEdit) or Table^.Bof;
  else
    TableBof:=true;
  end;
end;

procedure ForwardFill;
begin
  if Rec.OptionsEdit=0 then Table^.First;
  while not (TableEof or HasError) do
  begin
    Table^.Edit;
    F^.SetAsInteger(i);
    Table^.Post;
    if Rec.TypeProgers=0 then inc(i, Rec.IncrementEdit)
    else i:=i*Rec.IncrementEdit;
    Table^.Next;
    inc(Count);
  end;
  if HasError then HasError:=false;
end;

procedure BackwardFill;
begin
  if Rec.OptionsEdit=0 then Table^.Last;
  while not (TableBof or HasError)  do
  begin
    Table^.Edit;
    F^.SetAsInteger(i);
    Table^.Post;
    if Rec.TypeProgers=0 then inc(i, Rec.IncrementEdit)
    else i:=i*Rec.IncrementEdit;
    Table^.Prior;
    inc(Count);
  end;
  if HasError then HasError:=false;
end;

begin
  F:=CurField;
  if F=PField(RecNoField) then exit;
  if not (F^.FieldType in [ftInteger, ftFloat]) then
  begin
    RMessageBox(sArifmeticProgressError, nil, mfError+mfOkButton);
    exit;
  end;
  FillChar(Rec, SizeOf(TArifmeticProgersRecord), 0);
  Rec.FirstValueEdit:=1;
  Rec.IncrementEdit:=1;
{      TypeProgers:word;
      OptionsEdit:word;
      DirectionEdit:word;
      CountEdit:Longint;}
  if RExecDialog(sArifmetForm, @Rec)=cmOk then
  begin
    if not (Rec.OptionsEdit in [0,3]) then
    begin
      RMessageBox(sNotImplemented, nil, mfOkButton);
      exit;
    end;
    if Rec.IncrementEdit=0 then exit;
    Count:=0;
    CurPos:=Table^.GetBookmark;
    i:=Rec.FirstValueEdit;
    if Rec.DirectionEdit=0 then ForwardFill
    else BackwardFill;
    Table^.GotoBookmark(CurPos);
    Table^.FreeBookmark(CurPos);
  end;
end;

procedure TDBWindow.DoIdleFunc;
begin
  {$IFDEF WIN32}
  if UseAutoRefresh and IsNotification then
  begin
    Table^.Refresh;
    UpdateStatus;
  end;
  {$ENDIF}
end;

procedure TDBWindow.AddRecordsFromTable;
var AFileName:FNameStr;
    Metod:array [1..2] of word;
    ATable:PDbfTable;
    Stop:boolean;
    P,P1:PField;

procedure CopyByName;
var i:integer;
begin
  for i:=ord(RecNoField<>nil) to Table^.FieldDefs^.Count-1 do
  begin
    P:=Table^.Fields(i);
    P1:=ATable^.FindField(P^.Name^);
    if P1=nil then
      if Metod[2]<>0 then
      begin
        Stop:=true;
        exit;
      end
      else Continue;
    P^.Assign(P1);
    if HasError then
    begin
      HasError:=false;
      Stop:=true;
      exit;
    end;
  end;
end;

procedure CopyByNum;
var i:integer;

begin
  for i:=0 to Min(ATable^.FieldDefs^.Count-1, Table^.FieldDefs^.Count-1-ord(RecNoField<>nil)) do
  begin
    P:=Table^.Fields(i+ord(RecNoField<>nil));
    p1:=ATable^.Fields(i);
    P^.Assign(P1);
    if HasError then
    begin
      HasError:=false;
      Stop:=true;
      exit;
    end;
  end;
end;

begin
  AFileName:='*.dbf';
  FillChar(Metod, SizeOf(Metod), 0);
  if RExecDialog(sDbfOpenDlg,@AFileName)<>cmCancel then
    if RExecDialog(sSelFForm,@Metod)<>cmCancel then
    begin
      Stop:=false;
      ATable:=New(PDbfTable, Init(AFileName, stOpenRead));
      AFileName:=ExtractName(AFileName)+ExtractPath(AFileName);
      InitMesseges;
      while not (ATable^.Eof or Stop) do
      begin
        Table^.Append;
        if Metod[1]=0 then CopyByName
        else CopyByNum;
        Table^.Post;
        ReindexProc(ATable^.RecordCount, ATable^.RecNo, @AFileName);
        ATable^.Next;
      end;
      ATable^.Free;
      DoneMesseges;
      DS^.FirstRec;
    end;
end;

procedure LoadLocaleInformation;
begin
  ButtonName[0]:=GetString(sYes); {'~~'}
  ButtonName[1]:=GetString(sNo); {'~~'}
  ButtonName[2]:=GetString(sOk); {'~~'}
  ButtonName[3]:=GetString(sCancel); {'⬥'}
  Titles[0]:=GetString(sWarningStr);
  Titles[1]:=GetString(sErrorStr);
  Titles[2]:=GetString(sInfoStr);
  Titles[3]:=GetString(sConfirmStr);
end;

end.
